'use strict';

var _interopRequireDefault = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports['default'] = makeProxy;

var _difference = require('lodash/array/difference');

var _difference2 = _interopRequireDefault(_difference);

var SPECIAL_KEYS = ['constructor'];

function makeProxy(proxy) {
  var current = null;

  function createProxyMethod(key) {
    return function () {
      if (typeof current[key] === 'function') {
        return current[key].apply(this, arguments);
      }
    };
  }

  return function proxyTo(fresh) {
    // Save current source of truth
    current = fresh;

    var freshKeys = Object.getOwnPropertyNames(fresh);
    var currentKeys = Object.getOwnPropertyNames(proxy);
    var addedKeys = _difference2['default'](freshKeys, currentKeys, SPECIAL_KEYS);
    var removedKeys = _difference2['default'](currentKeys, freshKeys, SPECIAL_KEYS);

    // Update proxy method list
    addedKeys.forEach(function (key) {
      proxy[key] = createProxyMethod(key);
    });
    removedKeys.forEach(function (key) {
      delete proxy[key];
    });

    // The caller will use the proxy from now on
    return proxy;
  };
}

;
module.exports = exports['default'];